/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.sun.idm.rpc.spml2.extended;

import com.sun.idm.rpc.spml2.SessionAwareSpml2Client;
import org.openspml.v2.msg.XMLMarshaller;
import org.openspml.v2.msg.spml.ExecutionMode;
import org.openspml.v2.msg.spml.Extensible;
import org.openspml.v2.msg.spml.PSOIdentifier;
import org.openspml.v2.msg.spml.Response;
import org.openspml.v2.msg.spml.LaunchProcessRequest;
import org.openspml.v2.profiles.dsml.DSMLAttr;
import org.openspml.v2.profiles.dsml.DSMLValue;
import org.openspml.v2.util.Spml2ExceptionWithResponse;
import org.openspml.v2.util.xml.ReflectiveXMLMarshaller;

/**
 *
 * @author ricky
 */
public class TestLaunchProcess {

    static public void main(String[] args) {
        SessionAwareSpml2Client client = null;
        XMLMarshaller mMarshaller = new ReflectiveXMLMarshaller();
        try {
            // config
            String url = "http://192.168.122.11:8080/idm/servlet/openspml2";
            String user = "configurator";
            String password = "configurator";
            // start client doing the login
            client = new SessionAwareSpml2Client(url);
            Response resLogin = client.login(user, password);
            System.err.println("LOGIN: " + mMarshaller.marshall(resLogin));
            // generate a launchprocess request
            LaunchProcessRequest req = new LaunchProcessRequest();
            req.setExecutionMode(ExecutionMode.SYNCHRONOUS);
            req.setPsoID(new PSOIdentifier("Sample Workflow", null, null));
            Extensible data = new Extensible();
            data.addOpenContentElement(new DSMLAttr("par1", "value1"));
            data.addOpenContentElement(new DSMLAttr("par2",
                    new DSMLValue[] {new DSMLValue("par2-val1"), new DSMLValue("par2-val2")}));
            req.setData(data);
            System.err.println("REQUEST: " + mMarshaller.marshall(req));
            Response resLaunch = client.send(req);
            System.err.println("RESPONSE: " + mMarshaller.marshall(resLaunch));
        } catch (Spml2ExceptionWithResponse e) {
            System.err.println("Error inside workflow execution");
            try {System.err.println(mMarshaller.marshall(e.getResponse()));} catch (Exception ex) {}
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (client != null) {
                try {client.logout();} catch(Exception e) {}
            }
        }
    }
}
