/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.openspml.v2.msg.spml;

import org.openspml.v2.msg.XMLMarshaller;
import org.openspml.v2.msg.XMLUnmarshaller;
import org.openspml.v2.profiles.dsml.DSMLAttr;
import org.openspml.v2.util.xml.ReflectiveDOMXMLUnmarshaller;
import org.openspml.v2.util.xml.ReflectiveXMLMarshaller;

/**
 * <complexType name="LaunchProcessRequestType">
 * <complexContent>
 * <extension base="spml:RequestType">
 * <sequence>
 * <element name="psoID" type="spml:PSOIdentifierType" />
 * <element name="data" type="spml:ExtensibleType" minOccurs="0" />
 * </sequence>
 * </extension>
 * </complexContent>
 * </complexType>
 *
 * @author ricky
 */
public class LaunchProcessRequest extends BasicRequest {

    // <element name="psoID" type="spml:PSOIdentifierType" minOccurs="0"/>
    // workflow name or id
    private PSOIdentifier m_psoID = null;
    // <element name="data" type="spml:ExtensibleType" />
    // inputs for tnamehe workflow
    private Extensible m_data = null;

    //
    // CONSTRUCTORS
    //
    public LaunchProcessRequest() {
    }

    public LaunchProcessRequest(String requestId, ExecutionMode executionMode,
            PSOIdentifier psoId, Extensible data) {
        super(requestId, executionMode);
        m_psoID = psoId;
        m_data = data;
    }

    //
    // GETTERS & SETTERS
    //
    public PSOIdentifier getPsoID() {
        return m_psoID;
    }

    public void setPsoID(PSOIdentifier psoID) {
        m_psoID = psoID;
    }

    public Extensible getData() {
        return m_data;
    }

    public void setData(Extensible data) {
        m_data = data;
    }

    //
    // HASH & EQUALS
    //
    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof LaunchProcessRequest)) {
            return false;
        }
        if (!super.equals(o)) {
            return false;
        }
        final LaunchProcessRequest launchProcessRequest = (LaunchProcessRequest) o;
        if (m_psoID != null ? !m_psoID.equals(launchProcessRequest.m_psoID) : launchProcessRequest.m_psoID != null) {
            return false;
        }
        if (m_data != null ? !m_data.equals(launchProcessRequest.m_data) : launchProcessRequest.m_data != null) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int result = super.hashCode();
        result = 29 * result + (m_psoID != null ? m_psoID.hashCode() : 0);
        result = 29 * result + (m_data != null ? m_data.hashCode() : 0);
        return result;
    }

    static public void main(String[] args) {
        try {
            LaunchProcessRequest req = new LaunchProcessRequest();
            req.setRequestID("req_id");
            req.setExecutionMode(ExecutionMode.SYNCHRONOUS);
            req.setPsoID(new PSOIdentifier("workflow name", null, null));
            Extensible data = new Extensible();
            data.addOpenContentElement(new DSMLAttr("par1", "value1"));
            data.addOpenContentElement(new DSMLAttr("par2", "value2"));
            req.setData(data);
            XMLMarshaller mMarshaller = new ReflectiveXMLMarshaller();
            System.err.println("REQUEST: " + mMarshaller.marshall(req));
            XMLUnmarshaller mUnmarshaller = new ReflectiveDOMXMLUnmarshaller();
            req = (LaunchProcessRequest) mUnmarshaller.unmarshall(mMarshaller.marshall(req));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
