/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.openspml.v2.msg.spml;

import org.openspml.v2.msg.XMLMarshaller;
import org.openspml.v2.msg.XMLUnmarshaller;
import org.openspml.v2.profiles.dsml.DSMLAttr;
import org.openspml.v2.util.xml.ReflectiveDOMXMLUnmarshaller;
import org.openspml.v2.util.xml.ReflectiveXMLMarshaller;

/**
 * <complexType name="LaunchProcessResponseType">
 * <complexContent>
 * <extension base="spml:ResponseType">
 * <sequence>
 * <element name="data" type="spml:ExtensibleType" minOccurs="0" />
 * </sequence>
 * </extension>
 * </complexContent>
 * </complexType>
 *
 * @author ricky
 */
public class LaunchProcessResponse extends BasicResponse {
    // <element name="data" type="spml:ExtensibleType" minOccurs="0" />
    // inputs for tnamehe workflow

    private Extensible m_data = null;

    //
    // CONSTRUCTORS
    //
    public LaunchProcessResponse() {
    }

    public LaunchProcessResponse(String[] errorMessages,
            StatusCode status,
            String requestID,
            ErrorCode error,
            Extensible data) {
        super(errorMessages, status, requestID, error);
        m_data = data;
    }

    //
    // GETTERS & SETTERS
    //
    public Extensible getData() {
        return m_data;
    }

    public void setData(Extensible data) {
        m_data = data;
    }

    //
    // EQUALS & HASH
    //
    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof LaunchProcessResponse)) {
            return false;
        }
        if (!super.equals(o)) {
            return false;
        }

        final LaunchProcessResponse launchProcessResponse = (LaunchProcessResponse) o;

        if (m_data != null ? !m_data.equals(launchProcessResponse.m_data) : launchProcessResponse.m_data != null) {
            return false;
        }

        return true;
    }

    @Override
    public int hashCode() {
        int result = super.hashCode();
        result = 29 * result + (m_data != null ? m_data.hashCode() : 0);
        return result;
    }

    //
    // TEST
    //
    
    static public void main(String[] args) {
        try {
            LaunchProcessResponse res = new LaunchProcessResponse();
            res.setError(ErrorCode.CUSTOM_ERROR);
            res.setStatus(StatusCode.FAILURE);
            res.addErrorMessage("An error");
            Extensible data = new Extensible();
            data.addOpenContentElement(new DSMLAttr("res1", "value1"));
            data.addOpenContentElement(new DSMLAttr("res2", "value2"));
            res.setData(data);
            XMLMarshaller mMarshaller = new ReflectiveXMLMarshaller();
            System.err.println("RESPONSE: " + mMarshaller.marshall(res));
            XMLUnmarshaller mUnmarshaller = new ReflectiveDOMXMLUnmarshaller();
            res = (LaunchProcessResponse) mUnmarshaller.unmarshall(mMarshaller.marshall(res));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
